﻿using UnityEngine;
using System.Collections;
using System;

public class flamesound : MonoBehaviour {
	rtcmixmain RTcmix;
	int objno = 1; // change this for multiple RTcmix instantiations
	public TextAsset flamescore1, flamescore2;
	string fscore1, fscore2;
	int RTcmix_is_running;

	private getMyTransform localsrc; // to get position relative to 'observer'


	// Use this for initialization
	void Start () {
		RTcmix_is_running = 0;

		fscore1 = flamescore1.text;
		fscore2 = flamescore2.text;

		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno);

		localsrc = GameObject.Find ("observer").GetComponent<getMyTransform> ();
	}
	
	// Update is called once per frame
	void Update () {
		if (RTcmix_is_running == 1) {
			Vector3 srcpos = localsrc.getTransform (gameObject); // this source relative to the 'observer' object
			// note swap of y and z axes
			RTcmix.setpfieldRTcmix (1, srcpos.x, objno);
			RTcmix.setpfieldRTcmix (2, srcpos.z, objno);
			RTcmix.setpfieldRTcmix (3, srcpos.y, objno);
		}
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			if (RTcmix_is_running == 0) {
				RTcmix.SendScore (fscore1, objno);
				RTcmix_is_running = 1;
			}
			RTcmix.SendScore (fscore2, objno);
		}
	}

	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
